module MbackupTests

open NUnit.Framework
open Mbackup.Lib

[<SetUp>]
let Setup () =
    ()

[<Test>]
let TestDumb () =
    Assert.Pass()

[<Test>]
let TestToMingwPath () =
    Assert.That("/cygdrive/c/", Is.EqualTo(ToMingwPath "c:\\"))
    Assert.That("/cygdrive/c/", Is.EqualTo(ToMingwPath "C:\\"))
    Assert.That("/cygdrive/c/foo", Is.EqualTo(ToMingwPath "C:\\foo"))
    Assert.That("/cygdrive/d/foo", Is.EqualTo(ToMingwPath "D:\\foo"))
    Assert.That("/cygdrive/d/Foo", Is.EqualTo(ToMingwPath "D:\\Foo"))
    Assert.That("/cygdrive/c/foo/bar/", Is.EqualTo(ToMingwPath "C:\\foo\\bar\\"))
    Assert.That("/cygdrive/c/foo/bar/baz.txt", Is.EqualTo(ToMingwPath "C:\\foo\\bar\\baz.txt"))
    Assert.That("/cygdrive/c/foo", Is.EqualTo(ToMingwPath "C:/foo"))
    Assert.That("/cygdrive/c/foo/bar", Is.EqualTo(ToMingwPath "C:/foo/bar"))
    Assert.That("/cygdrive/c/foo", Is.EqualTo(ToMingwPath "/c/foo"))
    Assert.That("/cygdrive/D/foo", Is.EqualTo(ToMingwPath "/D/foo"))
    Assert.That("/var/log", Is.EqualTo(ToMingwPath "/var/log"))

let mysprintf fmt = sprintf fmt

[<Test>]
let TestMyprintf () =
  Assert.That("123", Is.EqualTo(mysprintf "123"))
  Assert.That("123", Is.EqualTo(mysprintf "%d" 123))
  Assert.That("123 456", Is.EqualTo(mysprintf "%d %d" 123 456))

let mylogger fmt =
  let doAfter s =
    "INFO " + s
  Printf.ksprintf doAfter fmt

[<Test>]
let TestMylogger () =
  Assert.That("INFO 123", Is.EqualTo(mylogger "123"))
  Assert.That("INFO 123", Is.EqualTo(mylogger "%d" 123))
  Assert.That("INFO 123 456", Is.EqualTo(mylogger "%d %d" 123 456))
  Assert.That("INFO 123 456 a", Is.EqualTo(mylogger "%d %d %s" 123 456 "a"))
